#include"falter.h"

u_int32_t Falter::operator()(const char *str)
{
    const char *p = str;
    u_int32_t ret=0;
    u_int32_t sum=0;
    size_t pos=0;
    while(*p!='\0')
    {
	u_int32_t n;
	if('a' <= *p && *p <='z')      { n=*p-'a'; }
	else if('A' <= *p && *p <='Z') { n=*p-'A'; }
	else                           { n = 27+(*p & 3); }
	sum<<=5;
        sum|=n;
	pos=(pos+1)%6;
	if(pos==0)
	{
	    ret^=sum;
	    sum=0;
	}
	p++;
    }
    ret^=sum;
    return ret;
}

u_int32_t Falter::operator()(const RAMS::memchunk &mc)
{
    const RAMS::octet_t *p=mc.mem;
    u_int32_t ret=0;
    u_int32_t sum=0;
    size_t pos=0;
    while(p < mc.mem+mc.size)
    {
	u_int32_t n;
	if('a' <= *p && *p <='z')      { n=*p-'a'; }
	else if('A' <= *p && *p <='Z') { n=*p-'A'; }
	else                           { n = 27+(*p & 3); }
	sum<<=5;
        sum|=n;
	pos=(pos+1)%6;
	if(pos==0)
	{
	    ret^=sum;
	    sum=0;
	}
	p++;
    }
    ret^=sum;
    return ret;
}
