#include<string.h>
#include<iostream>
#include"CommonListIterator.h"
#include"PrimitivTypes.h"
#include"StringOut.h"

char buffer[4096];

void load(RAMS::CommonListAllocator &cla,const char *str)
{
    char ladepuffer[64];
    RAMS::memchunk *ladung = (RAMS::memchunk *)ladepuffer;
    ladung->size = strlen(str);
    memcpy(ladung->mem,str,ladung->size);
    memcpy(cla.add(sizeof(size_t)+ladung->size),ladepuffer,sizeof(size_t)+ladung->size);
}

int main(int argc,char **argv)
{
    RAMS::GrowingBuffer seg(buffer,4096);
    off_t *root=(off_t *)seg.wr_ptr(sizeof(off_t));
    RAMS::CommonListAllocator cla(seg,root);
   
    load(cla,"Rudolf");
    load(cla,"Regina");
    load(cla,"Pawel");

    for(RAMS::CommonListIterator i(seg,*root);!i.end();i.next())
    {
	RAMS::String *inhalt=(RAMS::String *)(i.content());
	std::cout << *inhalt << std::endl;
    }
}
