#include"PreDeclCollector.h"

PreDeclCollector::PreDeclCollector():lastnamespace_(0)
{
}

PreDeclCollector::~PreDeclCollector()
{
}

void PreDeclCollector::addClass(const char *namesp,const char *name)
{
    bool namespacechanged = (lastnamespace_ && namesp && strcmp(lastnamespace_,namesp)!=0);
    bool firstnamespace = (!lastnamespace_ && namesp!= 0);
    bool lastnamespace = (lastnamespace_ && !namesp);

    if(namespacechanged||lastnamespace)
    {  // close namespace
	free((void *)lastnamespace_);
	lastnamespace_ = 0;
	declarations_ << "};\n";
    }

    if(firstnamespace||namespacechanged)
    {
	declarations_ << "namespace " << namesp << "\n{\n";
	lastnamespace_ = strdup(namesp);
    }
    declarations_ << "class " << name << ";" << std::endl;
}

std::string PreDeclCollector::str()
{
    if(lastnamespace_)
    {
	free((void *)lastnamespace_);lastnamespace_=0;
	declarations_ << "};\n";
    }
    return declarations_.str();
}
