#include"classname2names.h"
#include<string>

std::string toupper(std::string s)
{
    std::string ret(s.size(),' ');
    for(int i=0;i<s.length();i++)
    {
	ret[i]=toupper(s[i]);
    }
    return ret;
}


Classname2names::Classname2names(const char *name)
{
    name_=name;
    headerfile_=name_ + ".h";
    bodyfile_ = name_ + ".cc";
    includestopper_ = toupper(name_)+"_H";
}

const char *Classname2names::name() 
{
    return name_.c_str();
}

const char *Classname2names::headerfilename()
{
    return headerfile_.c_str();
}

const char *Classname2names::bodyfilename()
{
    return bodyfile_.c_str();
}

const char *Classname2names::includestopper()
{
    return includestopper_.c_str();
}
