#include"ClassGenerator.h"
#include"classwriter.h"
#include"genresolver.h"
#include"GenSemantik.h"

extern "C" void set_ramsomf_factory(AbstractCodeFactory *f);
extern "C" const char *get_semantik_name();

class Global
{
public:
  Global()
  {
     set_ramsomf_factory(&cppcodefactory);
  };
private:
  CPPCodeFactory cppcodefactory;
};

Global global;

GenResolver genresolver;
GenSemantik gensemantik(get_semantik_name());

Package::Package(Scope *scope,const char *name,const char *id,const char *uri)
    :name_(name),scope_(scope)
{
}

void Package::addComment(const char *text,size_t len)
{
}

void Package::finish()
{
}

std::string Package::Name()
{
    return name_;
}
 
PackageGenerator *CPPCodeFactory::genPackage(Scope *scope,const char *name,const char *id,const char *uri)
{
    return new Package(scope,name,id,uri);
}

ClassGenerator *CPPCodeFactory::genClass(Scope *scope,const char *name,const char *id)
{
    const char *namesp = (scope ? scope->Name().c_str() : 0);
    genresolver.addClass(namesp,name);
    gensemantik.addClass(namesp,name);
    return new ClassWriter(scope,name,id);
}
