#include"classname2names.h"
#include<fstream>
#include"output.h"

int main(int argc,char **argv)
{
    if(argc<2)
    {
	std::cerr << "Usage: " << argv[0] << "Classname" << std::endl;
	return -1;
    }
    Classname2names cn(argv[1]);
    std::ofstream header(cn.headerfilename());
    header << "#ifndef " << cn.includestopper() << "\n"
	   << "#define " << cn.includestopper() << std::endl;
    header << "class " << cn.name() << "\n{\n";
    header << "public:\n";
    header << indent(1) << cn.name() << "();\n";
    header << indent(1) << "~" << cn.name() << "();\n";
    header << "};\n";
    header << "#endif" << std::endl;
    std::ofstream body(cn.bodyfilename());
    body << "#include\"" << cn.headerfilename() << "\"\n" << std::endl;
    body << cn.name() << "::" << cn.name() << "()\n{\n";
    body << "}\n" << std::endl;

    body << cn.name() << "::~" << cn.name() << "()\n{\n";
    body << "}\n" << std::endl;
}
