#include<iostream>
#include"L0_CBPrintSemantik.h"
#include"alltypes.h"
#include"StringOut.h"

void L0_CBPrintSemantik::cb_Class_begin(L0::Class* aClass)
{
    PrintComments(aClass);
    std::cout << "L0::Class " << aClass->name() << "\n{" << std::endl;
}

void L0_CBPrintSemantik::cb_Class_end(L0::Class* aClass)
{

   std::cout << "} //L0::Class" << std::endl;
}


void L0_CBPrintSemantik::cb_Package_begin(L0::Package* aPackage)
{
    PrintComments(aPackage);
    std::cout << "L0::Package " << aPackage->name() << "\n{" << std::endl;
}

void L0_CBPrintSemantik::cb_Package_end(L0::Package* aPackage)
{

   std::cout << "} //L0::Package" << std::endl;
}

void L0_CBPrintSemantik::cb_Property_begin(L0::Property* aProperty)
{
    PrintComments(aProperty);
    std::cout << "\tProperty ";
    if(aProperty->is_lower_valid()) std::cout << aProperty->lower();
    if(aProperty->is_lower_valid() || aProperty->is_upper_valid()) std::cout << ':';
    if(aProperty->is_upper_valid()) std::cout << aProperty->upper();
    std::cout << " " << aProperty->name() << std::endl; 
}

void L0_CBPrintSemantik::cb_Property_end(L0::Property* aProperty)
{
}

void L0_CBPrintSemantik::PrintComments(L0::Element *aElement)
{
    std::cout << "/* ";
    L0::Element::ownedComment_iterator ownedComment_it = aElement->get_ownedComment_iterator();
    while(!ownedComment_it.end())
    {
	L0::Comment *c=ownedComment_it();
	if(c->is_body_valid())
        { 	
	    std::cout << ownedComment_it()->body();
	}
	else
	{
	    std::cout << "empty Comment ";
	}
	ownedComment_it.next();
    }
    std::cout << " */" << std::endl;
}
