#include<iostream>
#include<ramsmof/StringOut.h>
#include"alltypes.h"
#include"L0ModelWriter.h"

L0ModelWriter model(1);

int main(int argc,char **argv)
{
   try
   {
       model.open("t0");
       L0::Package apackage;
       model.root(&apackage);
       apackage.name("T0");
       L0::Class aclass;
       L0::Type *t=apackage.add_ownedType(&aclass);
       aclass.name("C1");

       model.save();
   }
   catch(std::exception &ex)
   {
       std::cerr << "Error: " << ex.what() << std::endl;
   }
}
