#include<iostream>
#include"Buch.h"
#include<unistd.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include"StringOut.h"

char buffer[4096];

int main(int argc,char **argv)
{
   RAMS::GrowingBuffer myseg(buffer,4096,0);
   bool neu=true;
   try
   {
      int fd=-1;
      fd=open("personenbuch.per",O_RDONLY);
      if(fd > 0)
      { 
        std::cerr << "reading personenbuch.per ..." << std::endl;
        int nr=read(fd,buffer,1024);
        myseg.grow(nr);
        neu=false;
        close(fd);
      }
      else
      {
        std::cerr << "personenbuch.per not exists, generate new one " << std::endl; 
      }
      Buch personenbuch(&myseg);
      if(neu)
      {
	  Person pers;
	  Person *pp;
	  pp = personenbuch.add_member(&pers);
          pp->Familyname("Weber");
	  pp->PreName("Rudolf");

	  pp = personenbuch.add_member(&pers);
          pp->Familyname("Weberova");
	  pp->PreName("Regina");

	  pp = personenbuch.add_member(&pers);
          pp->Familyname("Petiukonis");
	  pp->PreName("Pawel");
      }
      int c=0;
      for(Buch::member_iterator i = personenbuch.get_member_iterator();
	  !i.end();i.next())
      {
	  Person* p = i();
	  std::cout << "------- " << c << " -------" << std::endl;
	  std::cout << "Name   =" << p->Familyname() << std::endl;
	  std::cout << "Vorname=" << p->PreName() << std::endl;
	  c++;
      }
      fd=open("personenbuch.per",O_CREAT|O_TRUNC|O_WRONLY,0644);
      if(fd<-1) { std::cerr << "Can't write personenbuch.per" << std::endl; exit(1); }  
      int nw=write(fd,myseg.begin(),myseg.length());
   }
   catch(std::exception &ex)
   {
	std::cerr << "Exception: " << ex.what() << std::endl;
   }
}
