#include<iostream>
#include"Simple.h"
#include<unistd.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>

char buffer[4096];

int main(int argc,char **argv)
{
   RAMS::GrowingBuffer myseg(buffer,4096,0);
   try
   {
      int fd=-1;
      fd=open("simple.per",O_RDONLY);
      if(fd > 0)
      { 
        std::cerr << "reading simple.per ..." << std::endl;
        int nr=read(fd,buffer,1024);
        myseg.grow(nr);
        close(fd);
      }
      else
      {
        std::cerr << "simple.per not exists, generate new one " << std::endl; 
      }
      Simple simple(&myseg);
      std::cout << "is_simple=" << (simple.isSimple() ? "true" : "false") 
   	     << " count=" << simple.count() << std::endl;
      simple.isSimple(true);
      simple.count(simple.count()+1);
      std::cout << "is_simple=" << (simple.isSimple() ? "true" : "false") 
   	     << " count=" << simple.count() << std::endl;
      fd=open("simple.per",O_CREAT|O_TRUNC|O_WRONLY,0644);
      if(fd<0) { std::cerr << "Can't write simple.per" << std::endl; exit(1); }  
      int nw=write(fd,myseg.begin(),myseg.length());
   }
   catch(std::exception &ex)
   {
	std::cerr << "Exception: " << ex.what() << std::endl;
   }
}
