#include<iostream>
#include"Address.h"
#include<unistd.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include"StringOut.h"

char buffer[1024];

int main(int argc,char **argv)
{
   RAMS::GrowingBuffer myseg(buffer,4096,0);
   bool neu=true;
   try
   {
      int fd=-1;
      fd=open("address.per",O_RDONLY);
      if(fd > 0)
      { 
        std::cerr << "reading address.per ..." << std::endl;
        int nr=read(fd,buffer,1024);
        myseg.grow(nr);
        neu=false;
        close(fd);
      }
      else
      {
        std::cerr << "address.per not exists, generate new one " << std::endl; 
      }
      Address person(&myseg);
      if(neu)
      {
          person.Familyname("Weberova");
	  person.PreName("Regina");
	  person.City("Ravensgrad");
	  person.Street("Uliza Pajuodupio ");
	  person.Hausnr(30);
      }
      std::cout << "Name   =" << person.Familyname() << std::endl;
      std::cout << "Vorname=" << person.PreName() << std::endl;
      std::cout << "Ort    =" << person.City() << std::endl;
      std::cout << "Street =" << person.Street()
		<< " " << person.Hausnr() << std::endl;
      if(neu)
      {
        fd=open("address.per",O_CREAT|O_TRUNC|O_WRONLY,0644);
        if(fd<-1) { std::cerr << "Can't write address.per" << std::endl; exit(1); }  
        int nw=write(fd,myseg.begin(),myseg.length());
      }
   }
   catch(std::exception &ex)
   {
	std::cerr << "Exception: " << ex.what() << std::endl;
   }
}
