#ifndef XMIPARSERCONTEXT_CLASS_H
#define XMIPARSERCONTEXT_CLASS_H
#include"XMIParserContext.h"
#include"ClassGenerator.h"
#include"XMIParser_AttributInterpreter.h"

namespace XMIParser
{
    class ParserContext_Class : public ParserContext
    {
	
    public:
	ParserContext_Class(XMIparser *parser,const char *name,const char *xmiid,const AttributTab &atts);
	virtual ~ParserContext_Class();
	virtual std::string get_Name();
	virtual void startelement(const xmlChar *name,const xmlChar **atts);
	virtual void endelement(const xmlChar *name);
	virtual void addComment(const xmlChar *value,int len);
    private:
	std::string name_;
	ClassGenerator *classgen_;
	ElementGenerator *currele_;
    };
};
#endif

