#ifndef XMIPARSERCONTEXT_PACKAGE_H
#define XMIPARSERCONTEXT_PACKAGE_H
#include"XMIParserContext.h"
#include"ClassGenerator.h"

namespace XMIParser
{
    class ParserContext_Package : public ParserContext
    {
	
    public:
	ParserContext_Package(XMIparser *parser,const xmlChar **atts);
	~ParserContext_Package();
	virtual Scope *get_Scope();
	virtual std::string get_Name();
	virtual void startelement(const xmlChar *name,const xmlChar **atts);
	virtual void endelement(const xmlChar *name);
    private:
	std::string name_;
	Scope *package_;
    };
};
#endif

