#!/bin/bash
kname=$1
if [ -z $kname ]; then
  echo "Kein kontext name angegeben " 1>&2
  exit 1
fi
hfile="XMIParserContext_${kname}.h"
cfile="XMIParserContext_${kname}.cc"
ofile="XMIParserContext_${kname}.o"
if [ -f $hfile -o -f $cfile ]; then
	echo "`ls $hfile $cfile` exists " 1>&2
	exit 1;
fi
echo "CONTEXT(${kname})" | m4 XMIParserContext_h.m4 - > $hfile
echo "CONTEXT(${kname})" | m4 XMIParserContext_cc.m4 - > $cfile
echo -e "\t${ofile} \\" >> Makefile.erg
