#ifndef RAMSMOF_OBJECT_H
#define RAMSMOF_OBJECT_H
#include<RAMS/GrowingBuffer.h>
#include<ramsmof/types.h>
#include<ramsmof/Visitor.h>
namespace RAMS
{
namespace MOF
{
/**
 * Common Interface for all RAMSMOF accessor classes
 * This depends not on the concrete model
 */
class Object
{
public:
  virtual void _setsegandrep(RAMS::GrowingBuffer *place,RAMS::octet_t *rep)=0;
  virtual size_t _layout_size()=0;
  virtual ::RAMS::MOF::typeid_t _typeid()=0;
  virtual void _init()=0;
  // Visitor pattern
  virtual void _callVisitor(Visitor *v);
  virtual ~Object();
};
}; // MOF
}; // RAMS
#endif
