#include"ClassGenerator.h"
#include"xmiwriter.h"

extern "C" void set_ramsomf_factory(XMIFactory *f);

class Global
{
public:
  Global()
  {
     set_ramsomf_factory(&xmifactory);
  };
private:
  XMIFactory xmifactory;
};

Global global;


XMIPackageWriter::XMIPackageWriter(Scope *scope,const char *name,const char *id,const char *uri):name_(name)
{
}

void XMIPackageWriter::addComment(const char *text,size_t len)
{
}

void XMIPackageWriter::finish()
{
}

std::string XMIPackageWriter::Name()
{
    return name_;
}

PackageGenerator *XMIFactory::genPackage(Scope *scope,const char *name,const char *id,const char *uri)
{
    return new XMIPackageWriter(scope,name,id,uri);
}

ClassGenerator *XMIFactory::genClass(Scope *scope,const char *name,const char *id)
{
    return new XMIWriter(scope,name,id);
}
