#include"L0ElementGenerator.h"
#include"Comment.h"

L0ElementGenerator::L0ElementGenerator(L0::Element *element):element_(element)
{
}

L0ElementGenerator::~L0ElementGenerator()
{
}

void L0ElementGenerator::addComment(const char *text,size_t len)
{
    L0::Comment acomment;
    element_->add_ownedComment(&acomment);
    acomment.body(text,len);
}

void L0ElementGenerator::finish()
{
    delete element_;
    delete this;
}
