#include<iostream>
#include"Firma.h"
#include<unistd.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include"StringOut.h"

char buffer[1024];

int main(int argc,char **argv)
{
   RAMS::GrowingBuffer myseg(buffer,4096,0);
   bool neu=true;
   try
   {
      int fd=-1;
      fd=open("firma.per",O_RDONLY);
      if(fd > 0)
      { 
        std::cerr << "reading firma.per ..." << std::endl;
        int nr=read(fd,buffer,1024);
        myseg.grow(nr);
        neu=false;
        close(fd);
      }
      else
      {
        std::cerr << "firma.per not exists, generate new one " << std::endl; 
      }
      Firma meine(&myseg);
      if(neu)
      {
         Person inhaber;
         Person *p;
	 meine.Inhaber(&inhaber);
	 p = meine.Inhaber();
	 p->Familyname("Weber");
	 p->PreName("Rudolf");
	 meine.Fokus("Informatik");
	 delete p;
      }
      Person *inhaber;
      inhaber = meine.Inhaber();
      std::cout << "Name   =" << inhaber->Familyname() << std::endl;
      std::cout << "Vorname=" << inhaber->PreName() << std::endl;
      std::cout << "Fokus  =" << meine.Fokus() << std::endl;
      delete inhaber;
      if(neu)
      {
        fd=open("firma.per",O_CREAT|O_TRUNC|O_WRONLY,0644);
        if(fd<-1) { std::cerr << "Can't write firma.per" << std::endl; exit(1); }  
        int nw=write(fd,myseg.begin(),myseg.length());
      }
   }
   catch(std::exception &ex)
   {
	std::cerr << "Exception: " << ex.what() << std::endl;
   }
}
