#include<iostream>
#include<libxml/xmlmemory.h>
#include<libxml/parser.h>
#include"XMIParserContext_Comment.h"
#include"coutput.h"
#include<string>
using namespace XMIParser;

ParserContext_Comment::ParserContext_Comment(XMIparser *parser,const xmlChar **atts):ParserContext(parser),regardchar_(false),annotatedElement_(0)
{
    const xmlChar **a = atts;
    if(atts!=0)
    {
	while(*a!=0)
	{
	    if(xmlStrcmp(*a, (const xmlChar *) "annotatedElement")==0)
	    {
		annotatedElement_=strdup((const char *)*(++a));
	    }
	    a++;
	}
    }
}

ParserContext_Comment::~ParserContext_Comment()
{
    if(annotatedElement_)
    {
	free(annotatedElement_);
    }
}

void ParserContext_Comment::startelement(const xmlChar *name,const xmlChar **atts)
{
    inclevel();
    //std::cerr << "(" << level_ << ")";
    //std::cerr << "Comment:startelement " << name << std::endl;
    if(xmlStrcmp(name, (const xmlChar *) "body")==0)
    {
	regardchar_=true;
    }
    else
    {
	std::cerr << "Unhandeled Element " << name << std::endl;
    }
}

void ParserContext_Comment::endelement(const xmlChar *name)
{
    //std::cerr << "(" << level_-1 << ") Comment: endelement" << name << std::endl;
    if(xmlStrcmp(name, (const xmlChar *) "body")==0)
    {
	regardchar_=false;
    }
    declevel();
}

void ParserContext_Comment::characters(const xmlChar *value,int len)
{
    if(regardchar_ && prev_)
    {
	if(annotatedElement_)
	{	 
	}
	prev_->addComment(value,len);
    }
}
