#include<iostream>
#include<libxml/xmlmemory.h>
#include<libxml/parser.h>
#include"XMIParserContext_Initial.h"
#include"XMIParserContext_XMI.h"

using namespace XMIParser;

void ParserContext_Initial::startelement(const xmlChar *name,const xmlChar **atts)
{
    ParserContext_XMI *xmictx=0;
    std::cerr << "Initial:startelement" << std::endl;
    if (xmlStrcmp(name, (const xmlChar *) "xmi:XMI"))
    {
	throw XMIError("Illegal startElement %s",(const xmlChar *)name);
    }
    xmictx=new ParserContext_XMI(parser_);
    parser_->push(xmictx);
}

void ParserContext_Initial::endelement(const xmlChar *name)
{
    std::cerr << "Initial::endelement " << name << std::endl;
}
