#include<iostream>
#include<libxml/xmlmemory.h>
#include<libxml/parser.h>
#include"XMIParserContext_Rule.h"
#include"coutput.h"
#include<string>

using namespace XMIParser;

ParserContext_Rule::ParserContext_Rule(XMIparser *parser):ParserContext(parser),regardchar_(false)
{
}

ParserContext_Rule::~ParserContext_Rule()
{
}

void ParserContext_Rule::startelement(const xmlChar *name,const xmlChar **atts)
{
    inclevel();
    if(xmlStrcmp(name, (const xmlChar *) "body")==0)
    {
	regardchar_=true;
    }
    else
    {
	//std::cerr << "Unhandeled Element " << name << std::endl;
    }
}

void ParserContext_Rule::endelement(const xmlChar *name)
{
    //std::cerr << "(" << level_ << ") Rule: endelement " << name << std::endl;
    if(xmlStrcmp(name, (const xmlChar *) "body")==0)
    {
	regardchar_=false;
    }
    declevel();
}

void ParserContext_Rule::characters(const xmlChar *value,int len)
{
    if(regardchar_)
    {
	std::string com((const char *)value,len);
	Cindent cindent(*parser_);
	std::cout << cindent << "/* " << com << " */" << std::endl;  
    }
}
